Index: /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/dialogs/SelectTestScenariosAndRequirementsDialog.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/dialogs/SelectTestScenariosAndRequirementsDialog.java	(revision 909)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/dialogs/SelectTestScenariosAndRequirementsDialog.java	(revision 910)
@@ -2,11 +2,8 @@
 
 import java.util.ArrayList;
-import java.util.Collections;
-import java.util.Comparator;
 import java.util.HashMap;
 import java.util.HashSet;
 import java.util.List;
 
-import org.eclipse.emf.common.util.EList;
 import org.eclipse.jface.dialogs.IDialogConstants;
 import org.eclipse.jface.dialogs.TitleAreaDialog;
@@ -25,4 +22,6 @@
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Control;
+import org.eclipse.swt.widgets.Event;
+import org.eclipse.swt.widgets.Listener;
 import org.eclipse.swt.widgets.Shell;
 import org.eclipse.swt.widgets.TabFolder;
@@ -32,11 +31,12 @@
 import org.eclipse.ui.ISharedImages;
 import org.eclipse.ui.PlatformUI;
+import org.eclipse.uml2.uml.Class;
 import org.eclipse.uml2.uml.Element;
 import org.eclipse.uml2.uml.NamedElement;
-import org.eclipse.uml2.uml.Namespace;
 import org.openmodelica.modelicaml.common.dialogs.DialogMessage;
 import org.openmodelica.modelicaml.common.services.ModelicaMLServices;
 import org.openmodelica.modelicaml.common.utls.ResourceManager;
 import org.openmodelica.modelicaml.helper.impl.TestScenariosCollector;
+import org.openmodelica.modelicaml.helper.impl.TestSimulationModelCombination;
 
 public class SelectTestScenariosAndRequirementsDialog extends TitleAreaDialog {
@@ -47,6 +47,6 @@
 	private HashSet<Element> discardedTestScenarios;
 	
-	// requirements that are referenced by the test scenarios and for which all clients are satisfied 
-	private HashSet<Element> selectedRequirements;
+//	// requirements that are referenced by the test scenarios and for which all clients are satisfied 
+//	private HashSet<Element> selectedRequirements;
 
 	// requirements that are referenced by the test scenarios and for which NOT all clients are satisfied 
@@ -70,4 +70,6 @@
 	private List<TreeItem> treeItems = new ArrayList<TreeItem>();
 
+	private HashMap<Element, TestSimulationModelCombination> tsToTestSimulationModelCombination;
+	
 	private static final int DECORATION_WARNING = 0 ;
 	private static final int DECORATION_ERROR = 1 ;
@@ -91,5 +93,6 @@
 			Element systemModel,
 			TestScenariosCollector tsc,
-			String collectionLog) {
+			String collectionLog,
+			HashMap<Element, TestSimulationModelCombination> tsToTestSimulationModelCombination) {
 		
 		super(parentShell);
@@ -97,9 +100,10 @@
 		this.selectedTestScenarios = selectedTestScenarios;
 		this.discardedTestScenarios = discardedTestScenarios;
-		this.selectedRequirements = selectedRequirements;
+//		this.selectedRequirements = selectedRequirements;
 		this.discardedRequirements = discardedRequirements;
 		this.systemModel = systemModel;
 		this.tsc = tsc;
 		this.collectionLog = collectionLog;
+		this.tsToTestSimulationModelCombination = tsToTestSimulationModelCombination;
 	}
 
@@ -129,16 +133,50 @@
 		TabFolder tabFolder = new TabFolder(container, SWT.NONE);
 		tabFolder.setBounds(10, 10, 616, 315);
-		
-		TabItem tbtmTestScenarios = new TabItem(tabFolder, SWT.NONE);
+
+		// TAB: Pre-selected test scenarios
+		TabItem tbtmPreSelectedTestScenarios = new TabItem(tabFolder, SWT.NONE);
 //		tbtmTestScenarios.setImage(ResourceManager.getPluginImage("org.eclipse.ui", "/icons/full/elcl16/close_view.gif"));
-		tbtmTestScenarios.setText("Test Scenarios");
-		
-		final Tree tree = new Tree(tabFolder, SWT.CHECK);
-		buildTree(tree);
-		
-		// Add the listener
-		tree.addSelectionListener(new CheckboxTreeSelectionListener());
-		
-		tbtmTestScenarios.setControl(tree);
+		String metricPreSelected = "("+selectedTestScenarios.size()+" of " + tsc.getAllTS().size() + ")";
+		tbtmPreSelectedTestScenarios.setText("Preselected Test Scenarios " + metricPreSelected);
+		
+		final Tree treePreSelectedTestScenarios = new Tree(tabFolder, SWT.CHECK);
+		buildTree(treePreSelectedTestScenarios, false);
+		
+		// Add listeners
+		treePreSelectedTestScenarios.addSelectionListener(new CheckboxTreeSelectionListener());
+		treePreSelectedTestScenarios.addListener(SWT.MouseDoubleClick, new Listener() {
+		      public void handleEvent(Event event) {
+		        Point point = new Point(event.x, event.y);
+		        TreeItem item = treePreSelectedTestScenarios.getItem(point);
+		        if (item != null) {
+		        	openDescription(item);
+		        }
+		      }
+		    });
+	
+		tbtmPreSelectedTestScenarios.setControl(treePreSelectedTestScenarios);
+		
+		// TAB: Discarded test scenarios
+		TabItem tbtmDiscardedTestScenarios = new TabItem(tabFolder, SWT.NONE);
+//		tbtmTestScenarios.setImage(ResourceManager.getPluginImage("org.eclipse.ui", "/icons/full/elcl16/close_view.gif"));
+		String metricDiscarded  = "("+discardedTestScenarios.size()+" of " + tsc.getAllTS().size() + ")";
+		tbtmDiscardedTestScenarios.setText("Discarded Test Scenarios " + metricDiscarded);
+		
+		final Tree treeDiscardedTestScenarios = new Tree(tabFolder, SWT.CHECK);
+		buildTree(treeDiscardedTestScenarios, true);
+		
+		// Add listeners
+		treeDiscardedTestScenarios.addSelectionListener(new CheckboxTreeSelectionListener());
+		treeDiscardedTestScenarios.addListener(SWT.MouseDoubleClick, new Listener() {
+		      public void handleEvent(Event event) {
+		        Point point = new Point(event.x, event.y);
+		        TreeItem item = treeDiscardedTestScenarios.getItem(point);
+		        if (item != null) {
+		        	openDescription(item);
+		        }
+		      }
+		    });
+		tbtmDiscardedTestScenarios.setControl(treeDiscardedTestScenarios);
+		
 
 		Button btnSelectAll = new Button(container, SWT.NONE);
@@ -170,4 +208,5 @@
 			public void mouseDown(MouseEvent e) {
 				for (TreeItem treeItem : treeItems) {
+					
 					treeItem.setChecked(false);
 					// remove from to maps.
@@ -200,7 +239,11 @@
 			@Override
 			public void mouseDown(MouseEvent e) {
-				tree.removeAll();
+				treePreSelectedTestScenarios.removeAll();
+				treeDiscardedTestScenarios.removeAll();
+				
 				clearAllLists();
-				buildTree(tree);
+				
+				buildTree(treePreSelectedTestScenarios, false);
+				buildTree(treeDiscardedTestScenarios, true);
 			}
 		});
@@ -234,33 +277,25 @@
 
 	
-	private void buildTree(Tree treeRoot){
-	
-			if (this.selectedTestScenarios != null) {
-	
-				/*
-				 *  collect packages (owner) of selected test scenarios and create tree items. 
-				 */
-				List<Element> packagesOfTheSelectedTestScenariosSorted = getSortedByName(getTestScenarioPackages(this.selectedTestScenarios));
-				createPkgTreeItems(treeRoot, packagesOfTheSelectedTestScenariosSorted, true, false);
-				
-				// Sort test scenarios alphabetically 
-				List<Element> selectedTestScenariosSorted = getSortedByName(this.selectedTestScenarios);
-				for (Element testScenario : selectedTestScenariosSorted) {
-					if (testScenario instanceof NamedElement) {
-						createTestScenarioTreeItem(treeRoot, testScenario, false);
-					}
-				}				
-			}
-			
-			if (discardedTestScenarios != null && discardedTestScenarios.size() > 0) {
-				List<Element> packagesOfTheDiscardedTestScenariosSorted = getSortedByName(getTestScenarioPackages(discardedTestScenarios));
-				createPkgTreeItems(treeRoot, packagesOfTheDiscardedTestScenariosSorted, false, true);
-	
-				// add discarded test scenarios so that the user can still decide to generate the simulation model for them
-				for (Element discardedTestScenario : discardedTestScenarios) {
-					createTestScenarioTreeItem(treeRoot, discardedTestScenario, true);
-				}
-			}
-		}
+	private void buildTree(Tree treeRoot, boolean isDiscardedTree){
+		
+		HashSet<Element> testScenarios = new HashSet<Element>();
+		if (this.selectedTestScenarios != null && !isDiscardedTree) {
+			testScenarios.addAll(this.selectedTestScenarios);
+		}
+		else if (this.discardedTestScenarios != null && isDiscardedTree) {
+			testScenarios.addAll(this.discardedTestScenarios);
+		}
+		
+		List<Element> packagesOfTheSelectedTestScenariosSorted = ModelicaMLServices.getSortedByName(getTestScenarioPackages(this.selectedTestScenarios));
+		createPkgTreeItems(treeRoot, packagesOfTheSelectedTestScenariosSorted, !isDiscardedTree, isDiscardedTree);
+		
+		List<Element> testScenariosSorted = ModelicaMLServices.getSortedByName(testScenarios);
+		for (Element testScenario : testScenariosSorted) {
+			if (testScenario instanceof NamedElement) {
+				createTestScenarioTreeItem(treeRoot, testScenario, isDiscardedTree);
+			}
+		}	
+
+	}
 
 	private HashSet<Element> getTestScenarioPackages(HashSet<Element> testScenarios){
@@ -305,4 +340,5 @@
 	
 	private TreeItem getPackageTreeItem(Tree treeRoot, Element testScenario, boolean isDiscarded){
+		
 		TreeItem pkgItem = null;
 		// find the right package node at the 1 tree-level.
@@ -327,5 +363,4 @@
 	private void createTestScenarioTreeItem(Tree treeRoot, Element testScenario, boolean isDiscarded){
 
-//		TreeItem testScenarioItem = new TreeItem(treeRoot, 0);
 		TreeItem pkgItem = getPackageTreeItem(treeRoot, testScenario, isDiscarded);
 		TreeItem testScenarioItem = null;
@@ -365,24 +400,25 @@
 		
 		// sort requirements by requirement id
-		List<Element> associatedRequirements = getSortedByRequirementId(tsc.getTsToReq().get(testScenario));
+		List<Element> associatedRequirements = ModelicaMLServices.getSortedByRequirementId(tsc.getTsToReq().get(testScenario));
 		if (associatedRequirements != null) {
 			
-			// create info item
-			TreeItem testScenarioReqInfoNodeItem = new TreeItem(testScenarioItem, 0);
-//			treeItems.add(testScenarioReqInfoNodeItem); // there is no need to know info items.
-			String infoNodeTitle = "";
-			if (isDiscarded) {
-				infoNodeTitle = "Linked requirements:";
-			}
-			else {
-				infoNodeTitle = "Can be used to verify '" + ((NamedElement)systemModel).getName() + "' against the following requirements: ";
-			}
-			testScenarioReqInfoNodeItem.setText(infoNodeTitle);
-			testScenarioReqInfoNodeItem.setImage(ResourceManager.getPluginImage("org.eclipse.ui", "/icons/full/obj16/info_tsk.gif"));
-			testScenarioReqInfoNodeItem.setGrayed(true);
+//			// create info item
+//			TreeItem testScenarioReqInfoNodeItem = new TreeItem(testScenarioItem, 0);
+////			treeItems.add(testScenarioReqInfoNodeItem); // there is no need to know info items.
+//			String infoNodeTitle = "";
+//			if (isDiscarded) {
+//				infoNodeTitle = "Linked requirements:";
+//			}
+//			else {
+//				infoNodeTitle = "Can be used to verify '" + ((NamedElement)systemModel).getName() + "' against the following requirements: ";
+//			}
+//			testScenarioReqInfoNodeItem.setText(infoNodeTitle);
+//			testScenarioReqInfoNodeItem.setImage(ResourceManager.getPluginImage("org.eclipse.ui", "/icons/full/obj16/info_tsk.gif"));
+//			testScenarioReqInfoNodeItem.setGrayed(true);
 			
 			// create requirement items
 			for (Element req : associatedRequirements) {
-				createRequirementTreeItem(testScenarioReqInfoNodeItem, req, testScenario, isDiscarded);
+//				createRequirementTreeItem(testScenarioReqInfoNodeItem, req, testScenario, isDiscarded);
+				createRequirementTreeItem(testScenarioItem, req, testScenario, isDiscarded);
 			}
 		}
@@ -391,6 +427,4 @@
 	private void createRequirementTreeItem(TreeItem parentItem, Element req, Element testScenario, boolean isDiscarded){
 		String prefix = requirementNamePrefix;
-		
-//		TreeItem reqItem = new TreeItem(testScenarioItem, 0);
 		TreeItem reqItem = new TreeItem(parentItem, 0);
 		treeItems.add(reqItem);
@@ -400,15 +434,10 @@
 		reqData.setTestScenarioElement(testScenario);
 		
+		// if this is a requirement for which not all required clients are satisfied:
 		if (this.discardedRequirements.contains(req)) {
-			reqData.setIsDiscarded(true);
-			// prefix = prefix + "(INCONSISTENT) ";
-			reqItem.setImage(decorateError(ResourceManager.getPluginImage("org.openmodelica.modelicaml.profile", "resources/icons/icons16/requirement.gif")));
-			
-			// indicate inconsistencies
-//			testScenarioItem.setImage(decorateWarning(ResourceManager.getPluginImage("org.openmodelica.modelicaml.profile", "resources/icons/icons16/calculationModel.gif")));
-
 			// DO NOT preselect 
 			reqItem.setChecked(false);
-			
+			reqData.setIsDiscarded(true);
+			reqItem.setImage(decorateError(ResourceManager.getPluginImage("org.openmodelica.modelicaml.profile", "resources/icons/icons16/requirement.gif")));
 			// propagate error to all parents
 			propagateDecoration(reqItem, DECORATION_ERROR);
@@ -416,12 +445,12 @@
 		else {
 			reqData.setIsDiscarded(false);
-			
-			// preselect
-			reqItem.setChecked(true);
 			reqItem.setImage(ResourceManager.getPluginImage("org.openmodelica.modelicaml.profile", "resources/icons/icons16/requirement.gif"));
 			
+			// if the discarded tree is being built then do not preselect requirements and add them to the initial map.
 			if (!isDiscarded) {
 				// initially add to map
 				addToTestScenarioToRequirementsMap(testScenario, req);
+				// preselect
+				reqItem.setChecked(true);
 			}
 		}
@@ -432,12 +461,117 @@
 		reqItem.setData(reqData);
 	}
-	
-	
-	
-	
-	
+
+	// Tree Item Description Handling ************************************************************************ 
+	
+	private void openDescription(TreeItem item){
+		Object data = item.getData();
+    	if (data instanceof TreeItemData) {
+			Element testSceanrio = null;
+    		if ( ((TreeItemData)data).isRequirement) {
+				// get the test scenario and create a description of the combination
+				testSceanrio = ((TreeItemData)data).getTestScenarioElement();
+			}
+			if ( ((TreeItemData)data).isTestScenario) {
+				// get the test scenario and create a description of the combination
+				testSceanrio = ((TreeItemData)data).getTestScenarioElement();
+			}
+			
+			if (testSceanrio != null) {
+				String description = createDescription(testSceanrio);
+				DialogMessage dialog = new DialogMessage(new Shell(), "Test Simulation Model: Details", 
+						"Details of the selected combination of system model and test scenario:", 
+						description);
+				dialog.open();
+			}
+		}
+	}
+	
+	private String createDescription(Element testScenario){
+		String description = "";
+		TestSimulationModelCombination tsmc = tsToTestSimulationModelCombination.get(testScenario);
+		if (tsmc != null) {
+			Element systemModel = tsmc.getSystemModel();
+			description = description +
+					lineDelimiterString + 
+					"\nSystem Model: '"+((NamedElement)systemModel).getName()+"' ("+((NamedElement)systemModel).getQualifiedName()+")" +
+					getAdditionalModelsString(tsmc.getRequiredModels_systemModel(), tsmc, systemModel) + 
+					
+					lineDelimiterString + 
+					"\nTest Scenario: '"+((NamedElement)testScenario).getName()+"'("+((NamedElement)testScenario).getQualifiedName()+")" +
+					getAdditionalModelsString(tsmc.getRequiredModels_testScenario(), tsmc, testScenario) 
+					;
+			
+				description = description + getRequirementsString("", tsmc.getRequirements(), tsmc);
+		}
+		return description.trim();
+	}
+	
+	private static final String lineDelimiterString = "\n";
+//		"\n------------------------------------------------------------------------------ \n";
+
+	
+	private String getAdditionalModelsString(HashSet<Element> set, TestSimulationModelCombination tsmc, Element model){
+		String string = "";
+		if (set != null && set.size() > 0) {
+			string = "\n    - models required in addition: \n";
+			string = string + getAdditionalModelsStringParts(set, "         ", tsmc)
+			 + getUnsatisfiedClients("    ", model, tsmc);
+		}
+		
+		return string;
+	}
+	
+	private String getRequirementsString(String prefix, HashSet<Class> set, TestSimulationModelCombination tsmc){
+		String string  = "";
+		HashSet<Element> tempSet = new HashSet<Element>();
+		for (Element element : set) {
+			tempSet.add(element);
+		}
+		
+		List<Element> sortedList = ModelicaMLServices.getSortedByName(tempSet);
+		for (Element requirement : sortedList) {
+			if (requirement instanceof NamedElement) {
+				string = string + lineDelimiterString;
+				string = string + prefix +"Requirement: '" + ((NamedElement)requirement).getName() 
+						+ "' ("+((NamedElement)requirement).getQualifiedName()+")";
+				string = string + getAdditionalModelsString(tsmc.getRequiredModels_requirements().get(requirement), tsmc, requirement) + "\n";
+			}
+		}
+		return string;
+	}
+	
+	private String getAdditionalModelsStringParts(HashSet<Element> set, String prefix, TestSimulationModelCombination tsmc){
+		String string  = "";
+		List<Element> sortedList = ModelicaMLServices.getSortedByName(set);
+		for (Element element : sortedList) {
+			if (element instanceof NamedElement) {
+				string = string + prefix + "- " + getAlwaysIncludeString(element, tsmc) + ((NamedElement)element).getName() 
+				+ " ("+((NamedElement)element).getQualifiedName()+")\n";
+			}
+		}
+		return string;
+	}
+	
+	private String getAlwaysIncludeString(Element model, TestSimulationModelCombination tsmc){
+		String string = "";
+		if (tsmc.getAlwaysInclude().contains(model)) {
+			return "(always) ";
+		}
+		
+		return string;
+	}
+	
+	private String getUnsatisfiedClients(String prefix, Element element, TestSimulationModelCombination tsmc){
+		String string = "";
+		String unsatisfiedClientsString = tsmc.getClientsDotPathAsString(tsmc.getUnsatisfiedRequiredClients(element));
+		if (!unsatisfiedClientsString.trim().equals("")) {
+			string = prefix + "- unsatisfied required clients: " + "\n";
+			string = string + "         " + unsatisfiedClientsString;
+		}
+		return string;
+	}
 	
 	// Utls ************************************************************************ 
-	
+
 	private void clearAllLists(){
 		selectedTestScenariosWithRequirements.clear();
@@ -472,57 +606,4 @@
 		}
 	}
-	
-	
-	private List<Element> getSortedByName(HashSet<Element> set){
-		if (set == null) { return null; }
-
-		List<Element> listSorted = new ArrayList<Element>(set);
-		Comparator<Element> c = new Comparator<Element>() {
-			@Override
-			public int compare(Element arg0, Element arg1) {
-				if (arg0 instanceof NamedElement) {
-					return ((NamedElement)arg0).getName().compareToIgnoreCase( ((NamedElement)arg1).getName());
-				}
-				return arg0.toString().compareToIgnoreCase(arg1.toString());
-			}
-		};
-		Collections.sort(listSorted, c);
-		
-		return listSorted;
-	}
-	
-	private List<Element> getSortedByQName(HashSet<Element> set){
-		if (set == null) { return null; }
-
-		List<Element> listSorted = new ArrayList<Element>(set);
-		Comparator<Element> c = new Comparator<Element>() {
-			@Override
-			public int compare(Element arg0, Element arg1) {
-				if (arg0 instanceof NamedElement) {
-					return ((NamedElement)arg0).getQualifiedName().compareToIgnoreCase( ((NamedElement)arg1).getQualifiedName());
-				}
-				return arg0.toString().compareToIgnoreCase(arg1.toString());
-			}
-		};
-		Collections.sort(listSorted, c);
-		
-		return listSorted;
-	}
-	
-	private List<Element> getSortedByRequirementId(HashSet<Element> set){
-		if (set == null) { return null; }
-		List<Element> listSorted = new ArrayList<Element>(set);
-		Comparator<Element> c = new Comparator<Element>() {
-			@Override
-			public int compare(Element arg0, Element arg1) {
-				return ModelicaMLServices.getRequirementID(arg0).trim().compareToIgnoreCase( ModelicaMLServices.getRequirementID(arg1).trim());
-			}
-		};
-		Collections.sort(listSorted, c);
-		
-		return listSorted;
-	}
-	
-	
 	
 	// Image handling ************************************************************************
@@ -588,9 +669,11 @@
 							selectedTestScenariosWithRequirements.put(tesSscenario, new HashSet<Element>());
 							
-							// get the info node:
-							TreeItem[] infoNode = ((TreeItem)event.item).getItems();
+//							// get the info node:
+//							TreeItem[] infoNode = ((TreeItem)event.item).getItems();
+//							
+//							// add all test scenario linked requirements to map
+//							TreeItem[] requirementsItems = infoNode[0].getItems();
 							
-							// add all test scenario linked requirements to map
-							TreeItem[] requirementsItems = infoNode[0].getItems();
+							TreeItem[] requirementsItems = ((TreeItem)event.item).getItems();
 							for (int i = 0; i < requirementsItems.length; i++) {
 								TreeItem reqItem = requirementsItems[i];
@@ -621,9 +704,11 @@
 								if (testScenarioItem.getItems() != null && testScenarioItem.getItems().length > 0) {
 								
-									// get the info node
-									TreeItem[] infoNode = testScenarioItem.getItems();
+//									// get the info node
+//									TreeItem[] infoNode = testScenarioItem.getItems();
+//									
+//									// add all test scenario linked requirements to map
+//									TreeItem[] requirementsItems = infoNode[0].getItems();
 									
-									// add all test scenario linked requirements to map
-									TreeItem[] requirementsItems = infoNode[0].getItems();
+									TreeItem[] requirementsItems = testScenarioItem.getItems();
 									for (int j = 0; j < requirementsItems.length; j++) {
 										TreeItem reqItem = requirementsItems[j];
Index: /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/handlers/TestSimulationModelsGenaratorHandler.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/handlers/TestSimulationModelsGenaratorHandler.java	(revision 910)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/handlers/TestSimulationModelsGenaratorHandler.java	(revision 910)
@@ -0,0 +1,246 @@
+/*
+ * This file is part of OpenModelica.
+ *
+ * Copyright (c) 1998-CurrentYear, Open Source Modelica Consortium (OSMC),
+ * c/o Linköpings universitet, Department of Computer and Information Science,
+ * SE-58183 Linköping, Sweden.
+ *
+ * All rights reserved.
+ *
+ * THIS PROGRAM IS PROVIDED UNDER THE TERMS OF GPL VERSION 3 LICENSE OR 
+ * THIS OSMC PUBLIC LICENSE (OSMC-PL). 
+ * ANY USE, REPRODUCTION OR DISTRIBUTION OF THIS PROGRAM CONSTITUTES RECIPIENT'S ACCEPTANCE
+ * OF THE OSMC PUBLIC LICENSE OR THE GPL VERSION 3, ACCORDING TO RECIPIENTS CHOICE. 
+ *
+ * The OpenModelica software and the Open Source Modelica
+ * Consortium (OSMC) Public License (OSMC-PL) are obtained
+ * from OSMC, either from the above address,
+ * from the URLs: http://www.ida.liu.se/projects/OpenModelica or  
+ * http://www.openmodelica.org, and in the OpenModelica distribution. 
+ * GNU version 3 is obtained from: http://www.gnu.org/copyleft/gpl.html.
+ *
+ * This program is distributed WITHOUT ANY WARRANTY; without
+ * even the implied warranty of  MERCHANTABILITY or FITNESS
+ * FOR A PARTICULAR PURPOSE, EXCEPT AS EXPRESSLY SET FORTH
+ * IN THE BY RECIPIENT SELECTED SUBSIDIARY LICENSE CONDITIONS OF OSMC-PL.
+ *
+ * See the full OSMC Public License conditions for more details.
+ *
+ * Main author: Wladimir Schamai, EADS Innovation Works / Linköping University, 2009-now
+ *
+ * Contributors: 
+ *   Uwe Pohlmann, University of Paderborn 2009-2010, contribution to the Modelica code generation for state machine behavior, contribution to Papyrus GUI adoptations
+ *   Parham Vasaiely, EADS Innovation Works / Hamburg University of Applied Sciences 2009-2011, implementation of simulation plugins
+ */
+package org.openmodelica.modelicaml.helper.handlers;
+
+import java.lang.reflect.InvocationTargetException;
+import java.util.HashSet;
+import java.util.List;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.runtime.IAdaptable;
+import org.eclipse.emf.common.command.Command;
+import org.eclipse.emf.common.command.CompoundCommand;
+import org.eclipse.emf.ecore.EObject;
+import org.eclipse.emf.transaction.RecordingCommand;
+import org.eclipse.emf.transaction.TransactionalEditingDomain;
+import org.eclipse.jface.dialogs.MessageDialog;
+import org.eclipse.jface.dialogs.ProgressMonitorDialog;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.papyrus.core.services.ServiceException;
+import org.eclipse.papyrus.core.services.ServicesRegistry;
+import org.eclipse.papyrus.core.utils.BusinessModelResolver;
+import org.eclipse.papyrus.core.utils.ServiceUtils;
+import org.eclipse.papyrus.core.utils.ServiceUtilsForActionHandlers;
+import org.eclipse.papyrus.resource.NotFoundException;
+import org.eclipse.papyrus.resource.uml.UmlModel;
+import org.eclipse.papyrus.resource.uml.UmlUtils;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.PlatformUI;
+import org.eclipse.uml2.uml.Class;
+import org.eclipse.uml2.uml.Element;
+import org.eclipse.uml2.uml.NamedElement;
+import org.openmodelica.modelicaml.common.dialogs.DialogMessage;
+import org.openmodelica.modelicaml.helper.impl.TestSimulationModelsGenarator;
+
+public class TestSimulationModelsGenaratorHandler extends AbstractHandler {
+
+	private EObject selectedElement = null;
+	private HashSet<Element> sourceModels; 
+	private Element targetPackage;
+	private Element requirementsPackage; 
+	private Element testScenariosPackage; 
+	private Element valueMediatorsPackage;
+	private TestSimulationModelsGenarator smg;
+	
+	/* (non-Javadoc)
+	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
+	 */
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		selectedElement = (EObject) adaptSelectedElement(getCurrentSelections().get(0));
+		
+		if (selectedElement instanceof Class) {
+			
+			/* TODO: let the user select the target package, requirements package, test scenarios package and the value mediators package.
+			 * preselect all to the root UML Model from which the user selected the models to generate the simulation models for.
+			 */
+			
+			sourceModels = new HashSet<Element>();
+			sourceModels.add((Class)selectedElement);
+			
+			// get the uml model
+			UmlModel papyrusModel = UmlUtils.getUmlModel();
+			if (papyrusModel != null ) {
+				try {
+					targetPackage = (Element) papyrusModel.lookupRoot();
+				} catch (NotFoundException e) {
+					e.printStackTrace();
+					MessageDialog.openError(new Shell(), "Target Package Selection", "Cannot access the root model in Papyrus.");
+				}
+			}
+
+//			targetPackage = ((Class)selectedElement).getModel();
+			requirementsPackage = ((Class)selectedElement).getModel(); 
+			testScenariosPackage = ((Class)selectedElement).getModel(); 
+			valueMediatorsPackage = ((Class)selectedElement).getModel();
+			
+			Boolean go = MessageDialog.openQuestion(new Shell(), "Please confirm ...", "This helper will create a package " +
+					"that will contain miltiple simulation models each including one test scenario and all requirements "+ 
+					"that can be tested using this test scenario and the selected system model." +
+					"\n\nNote, only simulation models that have test scenarios and requirements with appropriate value bindings will be collected." +
+					"\n\n" +
+					
+					"   - Selected system model: '" + ((Class)selectedElement).getName() + "'\n" + 
+					"   - Package to store generated Sim. Models in: '" + ((NamedElement)targetPackage).getName() + "'\n" + 
+					"   - Package for Requirements search: '" + ((NamedElement)requirementsPackage).getName() + "'\n" +
+					"   - Package for Test Scnearios search: '" + ((NamedElement)testScenariosPackage).getName() + "'\n" +
+					"   - Package for Value Mediators search: '" + ((NamedElement)valueMediatorsPackage).getName() + "'\n"
+					);
+			
+			if (go) {
+				try {
+					ServicesRegistry  serviceRegistry = ServiceUtilsForActionHandlers.getInstance().getServiceRegistry();
+					TransactionalEditingDomain  editingDomain = ServiceUtils.getInstance().getTransactionalEditingDomain(serviceRegistry);
+					
+					smg = new TestSimulationModelsGenarator(
+							sourceModels, 
+							targetPackage,  
+							requirementsPackage, 
+							testScenariosPackage, 
+							valueMediatorsPackage);
+					
+					if (!smg.isTestSimulationModelGenerationCanceled()) {
+						// execute 
+						editingDomain.getCommandStack().execute(getCommand(editingDomain));
+					}
+					if (!smg.isTestSimulationModelGenerationCanceled()) {
+						// show log
+						String msg = "Generation of Test Simulation Models for '" + ((NamedElement)selectedElement).getName() + "'\n" +
+									 "Number of created simulation models: " + smg.getUserSelectedTestScenarios().size() + "\n\n";
+
+						DialogMessage dialog = new DialogMessage(new Shell(), "Test Simulation Models Generation Log", 
+								"Data collecation and models generation log entries:", msg + smg.getLog().trim());
+						dialog.open();
+					}
+
+				} catch (ServiceException e) {
+					e.printStackTrace();
+				}
+			}
+		}
+		return null;
+	}
+
+	/**
+	 * Gets the test oracle element creation command.
+	 *
+	 * @param editingDomain the editing domain
+	 * @param owningClass the owning class
+	 * @return the test oracle element creation command
+	 */
+	protected Command getCommand(TransactionalEditingDomain editingDomain) {
+		CompoundCommand cc = new CompoundCommand("Generating simulation models for '" + ((Class)selectedElement).getQualifiedName() + "'");
+		Command command = new RecordingCommand(editingDomain) {
+			@Override
+			protected void doExecute() {
+				try {
+					smg.generate();
+					new ProgressMonitorDialog(new Shell()).run(true, true, smg);
+				} catch (InvocationTargetException e) {
+					e.printStackTrace();
+					MessageDialog.openError(new Shell(), "Simulation Models Generation Process Error", "It was not possible to invoce the generation of simulation models operation.");
+				} catch (InterruptedException e) {
+					e.printStackTrace();
+					MessageDialog.openError(new Shell(), "Simulation Models Generation Process Abort", "The generation of simulation models was canceled.");
+				}
+			}
+		};
+		cc.append(command);
+		return (cc.unwrap());
+	}
+	
+	/* (non-Javadoc)
+	 * @see org.eclipse.core.commands.AbstractHandler#isEnabled()
+	 */
+	@Override
+	public boolean isEnabled() {
+		// TODO Auto-generated method stub
+		return true;
+	}
+
+
+//	@Override
+//	public boolean isHandled() {
+//		// TODO Auto-generated method stub
+//		return false;
+//	}
+
+	
+	/**
+ * Gets the current selections.
+ * 
+ * @return the current selections
+ */
+private List<Object> getCurrentSelections() {
+		ISelection selection = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection();
+		if(selection instanceof IStructuredSelection) {
+			IStructuredSelection structuredSelection = (IStructuredSelection)selection;
+			return structuredSelection.toList();
+		}
+		return null;
+	}
+	
+	
+	/**
+	 * Adapt selected element.
+	 * 
+	 * @param selection
+	 *            the selection
+	 * @return the e object
+	 */
+	protected EObject adaptSelectedElement( Object selection) {
+		EObject eObject = null;
+		if(selection != null) {
+			if(selection instanceof IAdaptable) {
+				selection = ((IAdaptable)selection).getAdapter(EObject.class);
+			}
+			Object businessObject = BusinessModelResolver.getInstance().getBusinessModel(selection);
+			if(businessObject instanceof EObject) {
+				eObject = (EObject)businessObject;
+			}
+		}
+		return eObject;
+	}
+	
+	
+	
+
+	
+	
+	
+}
